package jcg.zheng.demo;

import java.nio.CharBuffer;
import java.util.function.Predicate;

import javax.swing.text.Segment;

public class DemoApp {

    private static final String MARY = "MARY";
    private static final String MSG = "\"%s\".contains( %s \"MARY\" ) returns %s";

    public static void main(String[] args) {
        if (args.length < 1) {
            System.out.println("Please enter one argument!");
        } else {
            String testString = args[0];

            Predicate<String> containsMary = s -> s.toUpperCase().contains(MARY);
            System.out.println(
                    String.format(MSG, testString, "String", containsMary.test(testString)));

            contains_CharBuffer(testString);
            contains_Segment(testString);
            contains_String(testString);
            contains_StringBuffer(testString);
            contains_StringBuilder(testString);

        }
    }

    private static void contains_CharBuffer(String value) {
        CharBuffer mary = CharBuffer.allocate(4);
        mary.append(MARY);
        mary.rewind();

        System.out.println(
                String.format(MSG, value, mary.getClass().getSimpleName(), value.contains(mary)));
    }

    private static void contains_Segment(String value) {
        Segment mary = new Segment(MARY.toCharArray(), 0, 4);

        System.out.println(
                String.format(MSG, value, mary.getClass().getSimpleName(), value.contains(mary)));

    }

    private static void contains_String(String value) {
        System.out.println(
                String.format(MSG, value, MARY.getClass().getSimpleName(), value.contains(MARY)));

    }

    private static void contains_StringBuffer(String value) {
        StringBuffer mary = new StringBuffer();
        mary.append(MARY);

        System.out.println(
                String.format(MSG, value, mary.getClass().getSimpleName(), value.contains(mary)));

    }

    private static void contains_StringBuilder(String value) {
        StringBuilder mary = new StringBuilder();
        mary.append(MARY);

        System.out.println(
                String.format(MSG, value, mary.getClass().getSimpleName(), value.contains(mary)));

    }

}
