package jcg.zheng.demo;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.apache.commons.lang3.StringUtils;
import org.junit.Test;

public class ApacheStringUtilsTest {

	private static final String MARY = "Mary";
	private static final String MARY_SENTENCE = "Mary is a developer";
	private static final String MARY_UPPER = "MARY";

	@Test
	public void contains() {
		assertTrue(StringUtils.contains(MARY_SENTENCE, MARY));
		assertFalse(StringUtils.contains(MARY_SENTENCE, MARY_UPPER));
	}

	@Test
	public void containsAny() {
		assertTrue(StringUtils.containsAny(MARY_SENTENCE, MARY));	 
	}
	
	@Test
	public void containsIgnoreCase() {
		assertTrue(StringUtils.containsIgnoreCase(MARY_SENTENCE, MARY));
		assertTrue(StringUtils.containsIgnoreCase(MARY_SENTENCE, MARY_UPPER));
	}
	
	@Test
	public void containsNone() {
		assertTrue(StringUtils.containsNone(MARY_SENTENCE, "T"));	 
	}
	
	@Test
	public void containsOnly() {
		assertTrue(StringUtils.containsOnly(MARY_SENTENCE, MARY_SENTENCE));	 
	}

	@Test
	public void containsWhitespace() {
		assertTrue(StringUtils.containsWhitespace(MARY_SENTENCE));	 
	}

}
